﻿using System.Data;
using System.Collections.Generic;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 상품
    /// </summary>
    public class Product
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 상품 ID - ProductID

        /// <summary>
        /// 상품 ID
        /// </summary>
        public int ProductID { get; set; }

        #endregion
        #region 상품명 - ProductName

        /// <summary>
        /// 상품명
        /// </summary>
        public string ProductName { get; set; }

        #endregion
        #region 공급자 ID - SupplierID

        /// <summary>
        /// 공급자 ID
        /// </summary>
        public int? SupplierID { get; set; }

        #endregion
        #region 카테고리 ID - CategoryID

        /// <summary>
        /// 카테고리 ID
        /// </summary>
        public int? CategoryID { get; set; }

        #endregion
        #region 단위당 수량 - QuantityPerUnit

        /// <summary>
        /// 단위당 수량
        /// </summary>
        public string QuantityPerUnit { get; set; }

        #endregion
        #region 단가 - UnitPrice

        /// <summary>
        /// 단가
        /// </summary>
        public decimal? UnitPrice { get; set; }

        #endregion
        #region 재고 단위 - UnitsInStock

        /// <summary>
        /// 재고 단위
        /// </summary>
        public int? UnitsInStock { get; set; }

        #endregion
        #region 주문 단위 - UnitsOnOrder

        /// <summary>
        /// 주문 단위
        /// </summary>
        public int? UnitsOnOrder { get; set; }

        #endregion
        #region 재정렬 수준 - ReorderLevel

        /// <summary>
        /// 재정렬 수준
        /// </summary>
        public int? ReorderLevel { get; set; }

        #endregion
        #region 품절 여부 - Discontinued

        /// <summary>
        /// 품절 여부
        /// </summary>
        public bool Discontinued { get; set; }

        #endregion
        #region EAN13 - EAN13

        /// <summary>
        /// EAN13
        /// </summary>
        public string EAN13 { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 제품 리스트 구하기 - GetProductList(connection)

        /// <summary>
        /// 제품 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>제품 리스트</returns>
        public static List<Product> GetProductList(IDbConnection connection)
        {
            var resultList = connection.Query<Product>("SELECT * FROM Products ORDER BY ProductName ASC").ToList();

            return resultList;
        }

        #endregion
    }
}